classification
Title: Consider FreeBSD like any other OS in SOVERSION
Type: enhancement Stage: needs patch
Components: Build Versions: Python 3.5, Python 3.4, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: bapt, haypo, koobs, python-dev
Priority: normal Keywords: patch

Created on 2015-03-31 12:46 by bapt, last changed 2015-04-13 07:31 by haypo. This issue is now closed.

Files
File name Uploaded Description Edit
configure_ac.patch bapt, 2015-03-31 13:03 Path against configure.ac review
Messages (14)
msg239695 - (view) Author: bapt (bapt) Date: 2015-03-31 12:46
In the configuration script:
https://hg.python.org/cpython/file/47b2d1ff9743/configure.ac#l963

There is a special treatment done for FreeBSD, which is not needed, FreeBSD is perfectly fine with multiple digit in soversion.
msg239696 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2015-03-31 12:49
> https://hg.python.org/cpython/file/47b2d1ff9743/configure.ac#l963

This command was added by the changeset 6fc10306bf31.
msg239698 - (view) Author: bapt (bapt) Date: 2015-03-31 13:03
Adding a patch on configure.ac (I bet configure should not be patched but regenerated)

Considering the comment here: http://bugs.python.org/issue1044395#msg47064 about ldconfig(1) the output of ldconfig(1) is buggy in that regard, and the ports tree does not depends on that anymore so it will perfectly accept the 2 digit name.

There are no known other things depending on that buggy output
msg239699 - (view) Author: Kubilay Kocak (koobs) Date: 2015-03-31 13:05
+1
msg239703 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2015-03-31 13:29
> koobs	set	versions: + Python 2.7, Python 3.4, Python 3.5

Do you seriously consider to modify Python 2.7 and 3.4? Can it break the backward compatibility?

I don't know how the SOVERSION thing is used.
msg239708 - (view) Author: bapt (bapt) Date: 2015-03-31 13:40
Provide more information:
Here is a description of the problem with the FreeBSD ldconfig(1) problem and why it was a problem with libpython.so.*

https://wiki.freebsd.org/ports/fix_lib_depends

Here is the commit that adds the new methode for ports to lookup for libraries installed (not using ldconfig(1):
https://svnweb.freebsd.org/ports?view=revision&revision=322328
here is the commit that removes the ancient method:
https://svnweb.freebsd.org/ports?view=revision&revision=362031
msg239709 - (view) Author: bapt (bapt) Date: 2015-03-31 13:43
I do not think it is worth changing python 2.7 or python 3.4 given the fact that the .so.1 symlink is not created (which imho it should be a good idea to create but let's go step by step)

Let's just do it for next python
msg239950 - (view) Author: Kubilay Kocak (koobs) Date: 2015-04-03 01:48
@haypo, yes, absolutely and no

We will backport to security-only branches ourselves.
msg239954 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2015-04-03 05:37
Oh, I expected such change to break backward compatibility. If it doesn't,
it's fine.

Koobs, would you like to commit the patch?
msg240319 - (view) Author: Kubilay Kocak (koobs) Date: 2015-04-09 11:14
@haypo, if you could take care of the change in default, 3.4 and 2.7, we can backport the rest downstream. Thank you :)

@bapt, can you create a separate issue to cover the "create foo.so.X' symlink" request, so python@ (freebsd team) can work to patch locally with an upstream reference
msg240380 - (view) Author: Roundup Robot (python-dev) Date: 2015-04-09 20:30
New changeset 7444ac6d93c3 by Victor Stinner in branch 'default':
Issue #23817: FreeBSD now uses "1.0" the the SOVERSION as other operating
https://hg.python.org/cpython/rev/7444ac6d93c3
msg240381 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2015-04-09 20:31
> Let's just do it for next python

Ok.

I don't understand the purpose of SOVERSION, nor why it is an issue to not use dots on FreeBSD. So I don't want to change it in minor Python relases (2.7.x, 3.4.y).
msg240508 - (view) Author: Roundup Robot (python-dev) Date: 2015-04-11 23:01
New changeset 0b3027a2abbc by Ned Deily in branch 'default':
Issue #23817: run autoreconf to update configure.
https://hg.python.org/cpython/rev/0b3027a2abbc
msg240596 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2015-04-13 07:31
> Issue #23817: run autoreconf to update configure.

Oh thanks, I forgot to regenerate configure!
History
Date User Action Args
2015-04-13 07:31:03hayposetstatus: open -> closed
resolution: fixed
messages: + msg240596
2015-04-11 23:01:17python-devsetmessages: + msg240508
2015-04-09 20:31:53hayposetmessages: + msg240381
2015-04-09 20:30:02python-devsetnosy: + python-dev
messages: + msg240380
2015-04-09 11:14:54koobssetmessages: + msg240319
2015-04-03 05:37:23hayposetmessages: + msg239954
2015-04-03 01:48:01koobssetmessages: + msg239950
2015-03-31 13:43:37baptsetmessages: + msg239709
2015-03-31 13:40:03baptsetmessages: + msg239708
2015-03-31 13:29:17hayposetmessages: + msg239703
2015-03-31 13:05:14koobssettype: enhancement
stage: needs patch
messages: + msg239699
versions: + Python 2.7, Python 3.4, Python 3.5
2015-03-31 13:03:31baptsetfiles: + configure_ac.patch
keywords: + patch
messages: + msg239698
2015-03-31 12:49:56hayposetnosy: + haypo, koobs
messages: + msg239696
2015-03-31 12:46:47baptcreate